=== debian/changelog ===
snort (3.10.0.0-0kali1) kali-dev; urgency=medium

  * New upstream version 3.10.0.0
  * Update debian/copyright
  * Refresh patches
  * Update minimal required version of libdaq3-dev

 -- Sophie Brun <sophie@kali.org>  Mon, 08 Dec 2025 17:09:08 +0100
